/***************************************************************************
 *   Copyright (C) 2005-2007 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef MMSEPGDAO_H_
#define MMSEPGDAO_H_

#include "mmsdata/mmsepgdata.h"
#include "mmsdata/mmstvchanneldata.h"

class MMSEPGDAO {
    private:
        IMMSDB *dbConnection;

        void setMMSDBConnection(IMMSDB *connection);
        IMMSDB *getMMSDBConnection();
        
        void insert(MMSEPGData data);
        void update(MMSEPGData data);

        _MMSEPGData* moveRecordToData(MMSRecordSet &rs);

    public:
        MMSEPGDAO(IMMSDB *connection);

        void save(MMSEPGData data);
        void save(vector<MMSEPGData> dataList);

        void removeOldData();

        MMSEPGData findCurrentEPGDataByChannel(MMSTVChannelData* channel);
        vector<MMSEPGData> findNextEPGDataByChannel(MMSTVChannelData* channel, const unsigned int limit = 0);
        vector<MMSEPGData> findEPGDataByChannel(MMSTVChannelData* channel, const unsigned int limit = 0);
};

#endif /*MMSEPGDAO_H_*/
