/***************************************************************************
 *   Copyright (C) 2005-2007 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MMSEPGDATA_H_
#define MMSEPGDATA_H_

#include "mmstools/mmshandle.h"
#include "mmstools/mmstools.h"
#include "mmsdata/mmstvchanneldata.h"

class _MMSEPGData {
    friend class MMSEPGDAO;
    private:
        int    id;
        string startDate;
        string startTime;
        string startDT;
        time_t startStamp;
        string endDate;
        string endTime;
        string endDT;
        time_t endStamp;
        string title;
        string description;
        string longdescription;
        string language;
        string content;
        vector<pair<string, string> > 	components;
        MMSTVChannelData 				*channel;
        bool							scrambled;

        void setId(int id);
        void setStartDT(string startDT);
        void setEndDT(string endDT);

    public:
        _MMSEPGData();
        //
        int getId(void);
        //
        void setStartDate(const string startDate);
        string getStartDate(void);
        //
        void setStartTime(const string startTime);
        string getStartTime(void);
        //
        string getStartDT(void);
        //
        void setStartStamp(const time_t startStamp);
        time_t getStartStamp(void);
        //
        void setEndDate(const string endDate);
        string getEndDate(void);
        //
        void setEndTime(const string endTime);
        string getEndTime(void);
        //
        string getEndDT(void);
        //
        void setEndStamp(const time_t endStamp);
        time_t getEndStamp(void);
        //
        void setTitle(const string title);
        string getTitle(void);
        //
        void setDescription(const string description);
        string getDescription(void);
        //
        void setLongDescription(const string longdescription);
        string getLongDescription(void);
        
        void setLanguage(const string language);
        string getLanguage();
        
        void setContent(const string content);
        string getContent();
        
        void setChannel(MMSTVChannelData* channel);
        MMSTVChannelData* getChannel(void);
        
        void addComponent(const string lang, const string desc);
        vector<pair<string, string> > getComponents();
        
        void setScrambled(bool scrambled);
        bool getScrambled();
};

typedef MMSHandle<_MMSEPGData> MMSEPGData;

#endif /*MMSEPGDATA_H_*/
