/***************************************************************************
 *   Copyright (C) 2005-2007 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MMSEPGSERVICE_H_
#define MMSEPGSERVICE_H_

#include "mmsdata/mmsepgdata.h"

class MMSEPGService {
    private:
        IMMSDB		*dbconn;
    
    public:
        MMSEPGService(DataSource *datasource);
        virtual ~MMSEPGService();
        
        void setEPGData(MMSEPGData data);
        void setEPGData(vector<MMSEPGData> dataList);
        
        void removeOldData();

        MMSEPGData getCurrentEPGDataByChannel(MMSTVChannelData* channel);
        vector<MMSEPGData> getNextEPGDataByChannel(MMSTVChannelData* channel, const unsigned int limit = 0);
        vector<MMSEPGData> getEPGDataByChannel(MMSTVChannelData* channel, const unsigned int limit = 0);
};

#endif /*MMSEPGSERVICE_H_*/
