/***************************************************************************
 *   Copyright (C) 2005-2007 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *      Matthias Hardt   <mattmax@morphine.tv>                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MMSMUSICDATA_H_
#define MMSMUSICDATA_H_

#include "mmstools/mmstools.h"

class MMSMusicData {
    friend class MMSMusicDAO;
    
    private:
        int             id;
        string          filename;
        string          title;
        string          artist;
        string          album;
        string          genre;
        string          year;
        string          comment;
        unsigned int    rating;
        string          format;
        unsigned int    trackNumber, trackCount, length;
        string          cover;
        
        void setId(const int id);
        
    public:
        MMSMusicData();
        
        void setFilename(const string filename);
        void setTitle(const string title);
        void setArtist(const string artist);
        void setAlbum(const string album);
        void setGenre(const string genre);
        void setYear(const string year);
        void setComment(const string comment);
        void setRating(const unsigned int rating);
        void setFormat(const string format);
        void setTrackNumber(const unsigned int trackNumber);
        void setTrackCount(const unsigned int trackCount);
        void setLength(const unsigned int length);
        void setCover(const string cover);
        
        int          getId();
        string       getFilename();
        string       getTitle();
        string       getArtist();
        string       getAlbum();
        string       getGenre();
        string       getYear();
        string       getComment();
        unsigned int getRating();
        string       getFormat();
        unsigned int getTrackNumber();
        unsigned int getTrackCount();
        unsigned int getLength();
        string       getCover();
};

#endif /*MMSMUSICDATA_H_*/
