/***************************************************************************
 *   Copyright (C) 2005-2007 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *      Matthias Hardt   <mattmax@morphine.tv>                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MMSMUSICSERVICE_H_
#define MMSMUSICSERVICE_H_

#include "mmstools/mmstools.h"
#include "mmsdata/mmsmusicdao.h"

class MMSMusicService {
    private:
        IMMSDB      *dbconn;
    
    public:
        MMSMusicService(DataSource *datasource);
        virtual ~MMSMusicService();
        
        void setMusicData(MMSMusicData *data);
        void setMusicData(vector<MMSMusicData *> dataList);
        void getStatistics(unsigned int &numSongs, unsigned int &numArtists, unsigned int &numAlbums, unsigned int &numGenres);
        void getStatistics(unsigned int &numSongs, unsigned int &numArtists, unsigned int &numAlbums, unsigned int &numGenres, string &lastPlayed);
        void setLastPlayed(const string lastPlayed);
        vector <string *> getAlbums();
        vector <string *> getArtists();
        vector <string *> getGenres();
        vector <MMSMusicData *> getSongs();
        vector <MMSMusicData *> getSongsByAlbum(string album);
        vector <MMSMusicData *> getSongsByArtist(string artist);
        vector <MMSMusicData *> getSongsByGenre(string genre);
        MMSMusicData *getSongByFilename(string filename);

};

#endif /*MMSMUSICSERVICE_H_*/
