/***************************************************************************
 *   Copyright (C) 2005-2007 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MMSNEWSDATA_H_
#define MMSNEWSDATA_H_

#include "mmstools/mmstools.h"

class MMSNewsData {
    friend class MMSNewsDAO;
    private:
        int     id;
        int     sourceId;
        string  title;
        string  link;
        string  description;
        string  createDate;
        string  createTime;
        int     createTimeStamp;
        string  descText;
        string  descImages;
        string  pubDate;
        string  author;
        string  category;
        string  guid;

        void    setId(int id);

    public:
        MMSNewsData();

        int     getId();

        int     getSourceId();
        void    setSourceId(int sourceId);

        string  getTitle();
        void    setTitle(string title);

        string  getLink();
        void    setLink(string link);

        string  getDescription();
        void    setDescription(string description);

        string  getCreateDate();
        void    setCreateDate(string createDate);

        string  getCreateTime();
        void    setCreateTime(string createTime);

        int     getCreateTimeStamp();
        void    setCreateTimeStamp(int createTimeStamp);

        string  getDescText();
        void    setDescText(string descText);

        string  getDescImages();
        void    setDescImages(string descImages);

        string  getPubDate();
        void    setPubDate(string pubDate);

        string  getAuthor();
        void    setAuthor(string author);

        string  getCategory();
        void    setCategory(string category);

        string  getGuid();
        void    setGuid(string guid);
};

#endif /*MMSNEWSDATA_H_*/
