/***************************************************************************
 *   Copyright (C) 2005-2007 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MMSNEWSINFODATA_H_
#define MMSNEWSINFODATA_H_

#include "mmstools/mmstools.h"

class MMSNewsInfoData {
    friend class MMSNewsInfoDAO;
    private:
        int     id;
        int     sourceId;
        string  name;
        string  title;
        string  link;
        string  description;
        string  lastDate;
        string  lastTime;
        int     lastTimeStamp;
        int     lastRC;
        string  lastMSG;
        string  pubDate;
        string  copyright;

        void    setId(int id);
    
    public:  
        MMSNewsInfoData();
        //
        int     getId();
        //
        int     getSourceId();
        void    setSourceId(int sourceId);
        //
        string  getName();
        void    setName(string name);
        //
        string  getTitle();
        void    setTitle(string title);
        //
        string  getLink();
        void    setLink(string link);
        //
        string  getDescription();
        void    setDescription(string description);
        //
        string  getLastDate();
        void    setLastDate(string lastDate);
        //
        string  getLastTime();
        void    setLastTime(string lastTime);
        //
        int     getLastTimeStamp();
        void    setLastTimeStamp(int lastTimeStamp);
        //
        int     getLastRC();
        void    setLastRC(int lastRC);
        //
        string  getLastMSG();
        void    setLastMSG(string lastMSG);
        //
        string  getPubDate();
        void    setPubDate(string pubDate);
        //
        string  getCopyright();
        void    setCopyright(string copyright);
};

#endif /*MMSNEWSINFODATA_H_*/
