/***************************************************************************
 *   Copyright (C) 2005-2007 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *      Matthias Hardt   <mattmax@morphine.tv>                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MMSPHOTODATA_H_
#define MMSPHOTODATA_H_

#include "mmstools/mmstools.h"

class MMSPhotoData {
    friend class MMSPhotoDAO;
    
    private:
        int             id;
        string          filename;
        string          title;
        string          date;
        string          comment;
        unsigned int    rating;
        string          place;
        string          camera;
        string          album;
        string          albumCover;
        string          format;
        
        void setId(const int id);
        
    public:
        MMSPhotoData();
        ~MMSPhotoData() {};
        
        void setFilename(const string filename);
        void setTitle(const string title);
        void setDate(const string date);
        void setComment(const string comment);
        void setRating(const unsigned int rating);
        void setPlace(const string place);
        void setCamera(const string camera);
        void setAlbum(const string album);
        void setAlbumCover(const string albumCover);
        void setFormat(const string format);
        
        int          getId();
        string       getFilename();
        string       getTitle();
        string       getDate();
        string       getComment();
        unsigned int getRating();
        string       getPlace();
        string       getCamera();
        string       getAlbum();
        string       getAlbumCover();
        string       getFormat();
};

#endif /*MMSPHOTODATA_H_*/
