/***************************************************************************
 *   Copyright (C) 2005-2007 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *      Matthias Hardt   <mattmax@morphine.tv>                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MMSPHOTOSERVICE_H_
#define MMSPHOTOSERVICE_H_

#include "mmstools/mmstools.h"
#include "mmstools/mmsdbconnmgr.h"
#include "mmsdata/mmsphotodao.h"

class MMSPhotoService {
    private:
        IMMSDB     *dbconn;
    
    public:
        MMSPhotoService(DataSource *datasource);
        virtual ~MMSPhotoService();
        
        void setPhotoData(MMSPhotoData *data);
        void setPhotoData(vector<MMSPhotoData *> dataList);
        void getStatistics(unsigned int &numPhotos, unsigned int &numPlaces, unsigned int &numAlbums);
        void getStatistics(unsigned int &numPhotos, unsigned int &numPlaces, unsigned int &numAlbums, string &lastViewed);
        void setLastViewed(const string lastViewed);
        vector <string> getPlaces();
        vector < pair<string, string> > getAlbums();
        vector <MMSPhotoData *> getPhotos();
        vector <MMSPhotoData *> getPhotosByPlace(const string place);
        vector <MMSPhotoData *> getPhotosByAlbum(const string album);
        MMSPhotoData *getPhotoByFilename(const string filename);
        bool albumExists(const string album);
};

#endif /*MMSPHOTOSERVICE_H_*/
