/***************************************************************************
 *   Copyright (C) 2005-2007 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *      Matthias Hardt   <mattmax@morphine.tv>                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MMSVIDEODATA_H_
#define MMSVIDEODATA_H_

#include "mmstools/mmstools.h"

class MMSVideoData {
    friend class MMSVideoDAO;
    
    private:
        int             id;
        string          filename;
        string          title;
        string          cover;
        string          director;
        string          release;
        string          comment;
        unsigned int    rating;
        string          genre;
        string          format;
        
        void setId(const int id);
        
    public:
        MMSVideoData();
        
        void setFilename(const string filename);
        void setTitle(const string title);
        void setCover(const string cover);
        void setDirector(const string director);
        void setRelease(const string release);
        void setComment(const string comment);
        void setRating(const unsigned int rating);
        void setGenre(const string genre);
        void setFormat(const string format);
        
        int          getId();
        string       getFilename();
        string       getTitle();
        string       getCover();
        string       getDirector();
        string       getRelease();
        string       getComment();
        unsigned int getRating();
        string       getGenre();
        string       getFormat();
};

#endif /*MMSVIDEODATA_H_*/
