/***************************************************************************
 *   Copyright (C) 2005-2007 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *      Matthias Hardt   <mattmax@morphine.tv>                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MMSVIDEOSERVICE_H_
#define MMSVIDEOSERVICE_H_

#include "mmstools/mmstools.h"
#include "mmsdata/mmsvideodao.h"

class MMSVideoService {
    private:
        IMMSDB      *dbconn;
    
    public:
        MMSVideoService(DataSource *datasource);
        virtual ~MMSVideoService();
        
        void setVideoData(MMSVideoData *data);
        void setVideoData(vector<MMSVideoData *> dataList);
        void getStatistics(unsigned int &numVideos, unsigned int &numGenres);
        void getStatistics(unsigned int &numVideos, unsigned int &numGenres, string &lastPlayed);
        void setLastPlayed(const string lastPlayed);
        vector <string *> getGenres();
        vector <string *> getFormats();
        vector <MMSVideoData *> getVideos();
        vector <MMSVideoData *> getVideosByGenre(string genre);
        MMSVideoData *getVideoByFilename(string filename);
};

#endif /*MMSVIDEOSERVICE_H_*/
