/***************************************************************************
 *   Copyright (C) 2005-2007 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "mmsdata/mmsepgdata.h"

_MMSEPGData::_MMSEPGData() :
			id(-1),
			startDate(""),
			startTime(""),
			startDT(""),
			startStamp(0),
			endDate(""),
			endTime(""),
			endDT(""),
			endStamp(0),
			title(""),
			description(""),
			longdescription(""),
			language(""),
			content(""),
			channel(NULL),
			scrambled(false) {
}

void _MMSEPGData::setId(int id) {
    this->id = id;
}

int _MMSEPGData::getId(void) {
    return this->id;
}

void _MMSEPGData::setStartDate(const string startDate) {
    this->startDate = startDate;
}

string _MMSEPGData::getStartDate(void) {
    return this->startDate;
}

void _MMSEPGData::setStartTime(const string startTime) {
    this->startTime = startTime;
}

string _MMSEPGData::getStartTime(void) {
    return this->startTime;
}

void _MMSEPGData::setStartDT(const string startDT) {
    this->startDT = startDT;
}

string _MMSEPGData::getStartDT(void) {
    return this->startDT;
}

void _MMSEPGData::setStartStamp(const time_t startStamp) {
    this->startStamp = startStamp;
}

time_t _MMSEPGData::getStartStamp(void) {
    return this->startStamp;
}

void _MMSEPGData::setEndDate(const string endDate) {
    this->endDate = endDate;
}

string _MMSEPGData::getEndDate(void) {
    return this->endDate;
}

void _MMSEPGData::setEndTime(const string endTime) {
    this->endTime = endTime;
}

string _MMSEPGData::getEndTime(void) {
    return this->endTime;
}

void _MMSEPGData::setEndDT(const string endDT) {
    this->endDT = endDT;
}

string _MMSEPGData::getEndDT(void) {
    return this->endDT;
}

void _MMSEPGData::setEndStamp(const time_t endStamp) {
    this->endStamp = endStamp;
}

time_t _MMSEPGData::getEndStamp(void) {
    return this->endStamp;
}

void _MMSEPGData::setTitle(const string title) {
    this->title = title;
}

string _MMSEPGData::getTitle(void) {
    return this->title;
}

void _MMSEPGData::setDescription(const string description) {
    this->description = description;
}

string _MMSEPGData::getDescription(void) {
    return this->description;
}

void _MMSEPGData::setLongDescription(const string longdescription) {
    this->longdescription = longdescription;
}

string _MMSEPGData::getLongDescription(void) {
    return this->longdescription;
}

void _MMSEPGData::setLanguage(const string language) {
	this->language = language;
}

string _MMSEPGData::getLanguage() {
	return this->language;
}

void _MMSEPGData::setContent(const string content) {
	this->content = content;
}

string _MMSEPGData::getContent() {
	return this->content;
}

void _MMSEPGData::setChannel(MMSTVChannelData* channel) {
    this->channel = channel;
}

MMSTVChannelData* _MMSEPGData::getChannel(void) {
    return this->channel;
}

void _MMSEPGData::addComponent(const string lang, const string desc) {
	this->components.push_back(make_pair(lang, desc));
}

vector<pair<string, string> > _MMSEPGData::getComponents() {
	return this->components;
}

void _MMSEPGData::setScrambled(bool scrambled) {
	this->scrambled = scrambled;
}

bool _MMSEPGData::getScrambled() {
	return this->scrambled;
}
