/***************************************************************************
 *   Copyright (C) 2005-2007 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *      Matthias Hardt   <mattmax@morphine.tv>                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "mmsdata/mmsmusicdata.h"

MMSMusicData::MMSMusicData() : id(-1),
                               filename(""),
                               title(""),
                               artist(""),
                               album(""),
                               genre(""),
                               year(""),
                               comment(""),
                               rating(0),
                               format(""),
                               trackNumber(0),
                               trackCount(0),
                               length(0),
                               cover("") { 
}

void MMSMusicData::setId(const int id) {
    this->id = id;
}
        
void MMSMusicData::setFilename(const string filename) {
    this->filename = filename;
}

void MMSMusicData::setTitle(const string title) {
    this->title = title;
}

void MMSMusicData::setArtist(const string artist) {
    this->artist = artist;
}

void MMSMusicData::setAlbum(const string album) {
    this->album = album;
}

void MMSMusicData::setGenre(const string genre) {
    this->genre = genre;
}

void MMSMusicData::setYear(const string year) {
    this->year = year;
}

void MMSMusicData::setComment(const string year) {
    this->comment = comment;
}

void MMSMusicData::setFormat(const string format) {
    this->format = format;
}

void MMSMusicData::setTrackNumber(const unsigned int trackNumber) {
    this->trackNumber = trackNumber;
}

void MMSMusicData::setTrackCount(const unsigned int trackCount) {
    this->trackCount = trackCount;
}

void MMSMusicData::setRating(const unsigned int rating) {
    this->rating = rating;
}

void MMSMusicData::setLength(const unsigned int length) {
    this->length = length;
}

void MMSMusicData::setCover(const string cover) {
    this->cover = cover;
}

int MMSMusicData::getId() {
    return this->id;
}

string MMSMusicData::getFilename() {
    return this->filename;
}

string MMSMusicData::getTitle() {
    return this->title;
}

string MMSMusicData::getArtist() {
    return this->artist;
}

string MMSMusicData::getAlbum() {
    return this->album;
}

string MMSMusicData::getGenre() {
    return this->genre;
}

string MMSMusicData::getYear() {
    return this->year;
}

string MMSMusicData::getComment() {
    return this->comment;
}

string MMSMusicData::getFormat() {
    return this->format;
}

unsigned int MMSMusicData::getTrackNumber() {
    return this->trackNumber;
}

unsigned int MMSMusicData::getTrackCount() {
    return this->trackCount;
}

unsigned int MMSMusicData::getRating() {
    return this->rating;
}

unsigned int MMSMusicData::getLength() {
    return this->length;
}

string MMSMusicData::getCover() {
    return this->cover;
}
