/***************************************************************************
 *   Copyright (C) 2005-2007 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "mmsdata/mmsnewsinfoservice.h"
#include "mmstools/interfaces/immsdb.h"
#include "mmsdata/mmsnewsinfodao.h"

MMSNewsInfoService::MMSNewsInfoService(DataSource *datasource) :
    dbconn(NULL) {
    MMSDBConnMgr connMgr(datasource); 
    if((this->dbconn = connMgr.getConnection()))
    	this->dbconn->connect();
}

MMSNewsInfoService::~MMSNewsInfoService() {
	if(this->dbconn) {
		this->dbconn->disconnect();
		delete this->dbconn;
	}
}

void MMSNewsInfoService::setNewsInfo(MMSNewsInfoData *data) {
    MMSNewsInfoDAO myNewsInfoDAO(this->dbconn);
    myNewsInfoDAO.saveOrUpdate(data);
}

void MMSNewsInfoService::setNewsInfo(vector<MMSNewsInfoData *> dataList) {
    MMSNewsInfoDAO myNewsInfoDAO(this->dbconn);
    myNewsInfoDAO.saveOrUpdate(dataList);
}

MMSNewsInfoData *MMSNewsInfoService::getNewsInfoBySourceID(int sourceId) {
    MMSNewsInfoDAO myNewsInfoDAO(this->dbconn);
    MMSNewsInfoData *newsInfo;
    newsInfo = myNewsInfoDAO.findNewsInfoBySourceID(sourceId);
    
    return newsInfo;
}

vector<MMSNewsInfoData *> MMSNewsInfoService::getAllNewsInfos() {
    MMSNewsInfoDAO myNewsInfoDAO(this->dbconn);
    vector<MMSNewsInfoData *> newsInfos;
    newsInfos = myNewsInfoDAO.findAllNewsInfos();
    
    return newsInfos;
}
