/***************************************************************************
 *   Copyright (C) 2005-2007 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "mmsdata/mmsnewsservice.h"
#include "mmstools/interfaces/immsdb.h"
#include "mmsdata/mmsnewsdao.h"

MMSNewsService::MMSNewsService(DataSource *datasource) :
    dbconn(NULL) {
    MMSDBConnMgr connMgr(datasource); 
    if((this->dbconn = connMgr.getConnection()))
        this->dbconn->connect();
}

MMSNewsService::~MMSNewsService() {
	if(this->dbconn) {
        this->dbconn->disconnect();
        delete this->dbconn;
	}
}

void MMSNewsService::setNews(MMSNewsData *data) {
    MMSNewsDAO myNewsDAO(this->dbconn);
    myNewsDAO.saveOrUpdate(data);
}

void MMSNewsService::setNews(vector<MMSNewsData *> dataList) {
    MMSNewsDAO myNewsDAO(this->dbconn);
    myNewsDAO.saveOrUpdate(dataList);
}

vector<MMSNewsData *> MMSNewsService::getAllNews() {
    MMSNewsDAO myNewsDAO(this->dbconn);
    vector<MMSNewsData *> news;
    news = myNewsDAO.findAllNews();

    return news;
}

vector<MMSNewsData *> MMSNewsService::getAllNewsBySourceID(int sourceId) {
    MMSNewsDAO myNewsDAO(this->dbconn);
    vector<MMSNewsData *> news;
    news = myNewsDAO.findAllNewsBySourceID(sourceId);
    
    return news;
}

MMSNewsData *MMSNewsService::getNewsByID(int id) {
    MMSNewsDAO myNewsDAO(this->dbconn);
    MMSNewsData *retNews;
    retNews = myNewsDAO.findNewsByID(id);
    
    return retNews;
}

MMSNewsData *MMSNewsService::getNewsByNews(MMSNewsData news) {
    MMSNewsDAO myNewsDAO(this->dbconn);
    MMSNewsData *retNews;
    retNews = myNewsDAO.findNewsByNews(news);
    
    return retNews;
}
