/***************************************************************************
 *   Copyright (C) 2005-2007 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "mmsdata/mmstvchannelservice.h"
#include "mmstools/interfaces/immsdb.h"
#include "mmsdata/mmstvchanneldao.h"

MMSTVChannelService::MMSTVChannelService(DataSource *datasource) :
    dbconn(NULL) {
    MMSDBConnMgr connMgr(datasource); 
    if((this->dbconn = connMgr.getConnection()))
    	this->dbconn->connect();
}

MMSTVChannelService::~MMSTVChannelService() {
	if(this->dbconn) {
		this->dbconn->disconnect();
		delete this->dbconn;
	}
}

void MMSTVChannelService::setChannel(MMSTVChannelData *data) {
    MMSTVChannelDAO myTVChannelDAO(this->dbconn);
    myTVChannelDAO.save(data);
}

void MMSTVChannelService::setChannel(vector<MMSTVChannelData *> dataList) {
    MMSTVChannelDAO myTVChannelDAO(this->dbconn);
    myTVChannelDAO.save(dataList);
}

vector<MMSTVChannelData *> MMSTVChannelService::getAllChannels() {
    MMSTVChannelDAO channelDAO(this->dbconn);
    vector<MMSTVChannelData *> channels;
    channels = channelDAO.findAllChannels();

    return channels;
}

MMSTVChannelData *MMSTVChannelService::getChannelByName(string name) {
    MMSTVChannelDAO channelDAO(this->dbconn);
    MMSTVChannelData *channel;
    channel = channelDAO.findChannelByName(name);
    
    return channel;
}
