/***************************************************************************
 *   Copyright (C) 2005-2007 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *      Matthias Hardt   <mattmax@morphine.tv>                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "mmsdata/mmsvideodata.h"

MMSVideoData::MMSVideoData() : 
	id(-1),
	filename(""),
	title(""),
	cover(""),
	director(""),
	release(""),
	comment(""),
	rating(0),
	genre(""),
	format("") { 
}

void MMSVideoData::setId(const int id) {
    this->id = id;
}
        
void MMSVideoData::setFilename(const string filename) {
    this->filename = filename;
}

void MMSVideoData::setTitle(const string title) {
    this->title = title;
}

void MMSVideoData::setCover(const string cover) {
    this->cover = cover;
}

void MMSVideoData::setDirector(const string director) {
    this->director = director;
}

void MMSVideoData::setRelease(const string release) {
    this->release = release;
}

void MMSVideoData::setComment(const string comment) {
    this->comment = comment;
}

void MMSVideoData::setRating(const unsigned int rating) {
    this->rating = rating;
}

void MMSVideoData::setGenre(const string genre) {
    this->genre = genre;
}

void MMSVideoData::setFormat(const string format) {
    this->format = format;
}

int MMSVideoData::getId() {
    return this->id;
}

string MMSVideoData::getFilename() {
    return this->filename;
}

string MMSVideoData::getTitle() {
    return this->title;
}

string MMSVideoData::getCover() {
    return this->cover;
}

string MMSVideoData::getDirector() {
    return this->director;
}

string MMSVideoData::getRelease() {
    return this->release;
}

string MMSVideoData::getComment() {
    return this->comment;
}

unsigned int MMSVideoData::getRating() {
    return this->rating;
}

string MMSVideoData::getGenre() {
    return this->genre;
}

string MMSVideoData::getFormat() {
    return this->format;
}
